## cmake 2.8.0

=== debian/changelog ===
cmake (2.8.0-5ubuntu1) lucid; urgency=low

  * Merge from debian testing (LP: #497349). Remaining changes:
    - Keep the Replaces: on cmake-data to cover the Kubuntu version from
      Jaunty in case someone decides to do an (unsupported) Jaunty->Lucid
      upgrade.

 -- Artur Rona <ari-tczew@tlen.pl>  Wed, 16 Dec 2009 11:11:54 +0100

cmake (2.8.0-5) unstable; urgency=low

  * Skip the unpredictably long and rather pointless BootstrapTest
    (Closes: #558001).

 -- Modestas Vainius <modestas@vainius.eu>  Thu, 26 Nov 2009 14:20:46 +0200

cmake (2.8.0-4) unstable; urgency=medium

  * Replace bootstraptest_increase_timeout.diff with upstream version. My
    previous patch didn't work.
  * Revert previous "Build with g++-4.4 on hppa" change. It was not needed, build
    with default compiler on hppa.
  * Remove obsolete hack for parisc64 from debian/rules. It didn't work after
    switch to dh v7 anyway.
  * It should build on hppa now (Closes: #556653). So urgency=medium.

 -- Modestas Vainius <modestas@vainius.eu>  Wed, 25 Nov 2009 11:37:34 +0200

cmake (2.8.0-3) unstable; urgency=medium

  * Set HOME to current build directory when running test suite. This should
    fix failures of kwsys.testRegistry and FindPackageTest tests on the
    buildds.
  * Increase timeout of BootstrapTest to 2 hours so it no longer times out
    on s390 or armel (patch bootstraptest_increase_timeout.diff).
  * Fix GNU.cmake file used on Hurd. Thanks to Pino Toscano for the patch.
  * Build with g++-4.4 on hppa. May solve FTBFS (segfault likely due to
    miscompilation) reported in #556653.
  * Urgency medium due to likely RC bug fix (#556653).

 -- Modestas Vainius <modestas@vainius.eu>  Sun, 22 Nov 2009 20:49:29 +0200

cmake (2.8.0-2) experimental; urgency=low

  * Reenable test suite.

 -- Modestas Vainius <modestas@vainius.eu>  Sun, 22 Nov 2009 00:38:54 +0200

cmake (2.8.0-1) unstable; urgency=low

  * New upstream release.
  * Disable test suite for now.

 -- Modestas Vainius <modestas@vainius.eu>  Sat, 14 Nov 2009 01:59:25 +0200

cmake (2.8.0~rc6-1) experimental; urgency=low

  * New upstream development release.
  * Switch debian/rules to use dh v7:
    - bump debhelper build depends to 7.3;
    - also drop unused Dart handling in the process;
    - enable test suite.
  * Add myself as Maintainer, A. Maitland Bottoms as Uploader (with
    permission).

 -- Modestas Vainius <modestas@vainius.eu>  Tue, 10 Nov 2009 23:46:25 +0200

cmake (2.8.0~rc5-1) experimental; urgency=low

  * New upstream development release.
    - FindJNI.cmake does no longer get confused about multiple JVM installs
      (Closes: #553151).
  * Switch to dpkg-source format 3.0 (quilt):
    - drop build dependency on quilt;
    - drop quilt.make snippet include from debian/rules.
  * Build with CMAKE_USE_RELATIVE_PATHS=ON.
  * Drop tcp8.4 from build depends. Not needed.

 -- Modestas Vainius <modestas@vainius.eu>  Fri, 06 Nov 2009 22:47:17 +0200

cmake (2.8.0~rc3-1) experimental; urgency=low

  * New upstream development release.
    - ctest no longer segfaults on such a invalid input (Closes: #528530).
  * Drop all patches:
    - FindQt4.cmake2.6.diff - remove, no longer needed as original bug has been
      fixed since 2.6;
    - FindQt3.cmake.diff - remove, merged upstream;
    - findmpeg2-addpath.diff - remove, bug fixed upstream (in other way);
    - kfreebsd-Platform.diff - remove, merged upstream;
    - executables-dont-need-fpic.diff - remove, merged upstream;
    - manpage_friendly_docs.diff - remove, merged upstream;
    - fix_bashisms.diff - remove, merged upstream;
    - FindPerlLibs.cmake-perl-5.10.diff - remove, fixed upstream differently;
    - FindJNI.cmake-more-arches.diff - remove, was taken from upstream;
    - FindVTK.cmake-vtk-5.4.diff - remove, was taken from upstream.
  * Update install files.
  * Call dpkg with --print-architecture rather than obsolete 
    --print-installation-architecture.
  * Fix lintian override cmake-data: extra-license-file.
  * Remove obsolete README.Debian.
  * cmake-curses-gui should not provide cmake-gui.

 -- Modestas Vainius <modestas@vainius.eu>  Sun, 11 Oct 2009 15:09:42 +0300

cmake (2.6.4-3ubuntu1) lucid; urgency=low

  * Merge from debian testing, remaining changes:
    - Keep the Replaces: on cmake-data to cover the Kubuntu version from
      Jaunty in case someone decides to do an (unsupported) Jaunty->Lucid
      upgrade.

 -- Ryan Kavanagh <ryanakca@kubuntu.org>  Sun, 08 Nov 2009 10:20:12 -0500

cmake (2.6.4-3) unstable; urgency=low

  * Bump Standards-Version to 3.8.3, no changes needed.
  * Add ${misc:Depends} to Depends fields of packages.
  * Improve debian/watch:
    - make it scan remote directories recursively;
    - make it work with new upstream RC release mangling.
  * Remove Pierre Habouzit from Uploaders by his own request.
  * Backport FindJNI.cmake from CMake 2.8 CVS in order to make it arch
    independent on Linux. New FindJNI.cmake also supports most Linux arches and
    is capable of finding Sun Java, OpenJDK, Kaffe and GCJ (if latter is
    default-java) JVMs. Support for Debian specific /usr/lib/jvm/default-java is
    also included. Patch FindJNI.cmake-more-arches.diff (Closes: #544674).
  * Backport Modules/FindVTK.cmake from CMake 2.8 CVS. It adds support for VTK
    5.4. Patch FindVTK.cmake-vtk-5.4.diff (Closes: #546030).
  * Update debian/copyright with more details (Closes: #544290).
  * Make cmake-curses-gui and cmake-qt-gui packages provide 'cmake-gui'.

 -- Modestas Vainius <modestas@vainius.eu>  Wed, 30 Sep 2009 20:51:13 +0300

cmake (2.6.4-2) unstable; urgency=low

  * Prefer *-qt3 binary names to generic ones in FinqQt3.cmake
    (Closes: #538864).
  * Fix bashisms in CMake scripts (Closes: #530056).
  * Merge in 2.6.0-6 debian/changelog.
  * Use quilt.make rather than custom quilt patch implementation.
  * Make debian/rules dpkg-buildpackage -jX safe and support parallel
    in DEB_BUILD_OPTIONS (Closes: #538826).

